using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace CRM
{
    public class CheapBeamgunBehaviour : CanShoot
    {
        private GameObject Item;
        private PhysicalBehaviour physicalBehaviour;
        private GameObject ItemGlow;
        private Vector2 barrelPosition = new Vector2(0f, 0f);
        private Vector2 barrelDirection = new Vector2(1, 0);
        public bool upgraded = false;
        private LineRenderer laser;
        private LayerMask layers;
        private LayerMask bounds;
        private GameObject components;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];

        public void Start()
        {

            Item = gameObject;
            physicalBehaviour = GetComponent<PhysicalBehaviour>();

            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            components = new GameObject("components", typeof(Optout));
            components.transform.SetParent(transform);
            components.transform.localPosition = new Vector3(0, 0);
            laser = components.AddComponent<LineRenderer>();
            laser.SetPositions(new[] { Vector3.zero, Vector3.right * 1000 });
            laser.useWorldSpace = false;
            laser.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            laser.sortingLayerName = "Background";
            laser.startColor = new Color(70f, 70f, 70f, 1f);
            laser.endColor = new Color(60f, 60f, 60f, 1f);
            laser.widthMultiplier = 0.05f;
            laser.enabled = false;

            ItemGlow = new GameObject();
            ItemGlow.transform.parent = Item.transform;
            ItemGlow.transform.localPosition = new Vector3(0f, -0.13f);
            ItemGlow.transform.localScale = gameObject.transform.parent.localScale;
            ItemGlow.transform.localRotation = Quaternion.identity;
            var ItemSprite = ItemGlow.AddComponent<SpriteRenderer>();

            ItemSprite.sprite = ModAPI.LoadSprite("th.png");
            ItemSprite.material = ModAPI.FindMaterial("VeryBright");
            ItemSprite.color = new Color(70f, 70f, 70f, 0f);   
            ItemSprite.sortingLayerName = "Top";

        }
        private void Use()
        {
            Shoot();
        }
        public override void Shoot()
        {
        StartCoroutine(Fire());
        }
        private IEnumerator Fire()
        {

            const int iterations = 1;
            const float duration = 0.1f;
            const float interval = duration / iterations;
            laser.startColor = new Color(70f, 70f, 70f, 1f);
            laser.endColor = new Color(60f, 60f, 60f, 1f);
            laser.widthMultiplier = 0.02f;

            laser.enabled = true;
            for (int i = 0; i < iterations; i++)
            {
                var end = Physics2D.Raycast(BarrelPosition, BarrelDirection, 10000, bounds);
                var endPos = end.transform == null ? (Vector3)BarrelPosition + (Vector3)BarrelDirection * 10000 : (Vector3)end.point;
                var victimCount = Physics2D.LinecastNonAlloc(BarrelPosition, endPos, victimBuffer, layers);
                laser.SetPosition(1, components.transform.InverseTransformPoint(endPos));

                for (int n = 0; n < victimCount; n++)
                {
                var victim = victimBuffer[n];
		ExplosionCreator.CreatePulseExplosion(victim.point, 1f, 2, true);
		victim.transform.SendMessage("Break", SendMessageOptions.DontRequireReceiver);
		victim.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                }
                CameraShakeBehaviour.main.Shake(1, transform.position);
                physicalBehaviour.rigidbody.AddRelativeForce(new Vector2(0f * transform.localScale.normalized.x, 0), ForceMode2D.Impulse);
                yield return new WaitForSeconds(interval);
            }
            laser.enabled = false;
            yield return new WaitForSeconds(2f);
        }
        public override Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }
        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }
    }
}