using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {
        Liquid.Register("Copper Enriched Blood", new Purp());
        CategoryBuilder.Create("CoA -People", "Includes colonists which live in the Arcanus system.",ModAPI.LoadSprite("category1.png"));
        CategoryBuilder.Create("CoA -Tech", "Includes machinery and building parts for the Colonists of Arcanus.",ModAPI.LoadSprite("category2.png"));
        CategoryBuilder.Create("CoA -Tools", "Includes tools used by the Colonists of Arcanus.",ModAPI.LoadSprite("category3.png"));

            //Guided Missile
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Missile Launcher"),
                    NameOverride = "Federal Guided Missile Launcher",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Fires laser-guiderd missiles.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalJavelinView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalRocketLauncher.png", 1f);
                        Instance.FixColliders();
                    }
                }
            );
            //Colonist Cargo Crate
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Colonist Cargo Crate",
                    DescriptionOverride = "A cargo crate mainly used for civilian needs.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistCargoCrateView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistCargoCrate.png");
                    }
                }
            );
            //Federal Cargo Crate
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Federal Cargo Crate",
                    DescriptionOverride = "A cargo crate mainly used for military needs.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalCargoCrateView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalCargoCrate.png");
                    }
                }
            );
            //Federal Mini Thruster
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Mini Thruster"),
                    NameOverride = "Federal Mini Thruster",
                    DescriptionOverride = "What can I say except ya welcome",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalMiniThrusterView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalMiniThruster.png");
                    }
                }
            );
            //Federal Ion Thruster
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Ion Thruster"),
                    NameOverride = "Federal Ion Thruster",
                    DescriptionOverride = "Pretty cool, yeah it's pretty cool.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalIonThrusterView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalIonThruster.png");
                   	Instance.FixColliders();
                    }
                }
            );
            //Colonist Piston
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Piston"),
                    NameOverride = "Colonist Piston",
                    DescriptionOverride = "Finally! A regular piston!",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistPistonView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistPiston.png");
                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistPistonHead.png");
                    }
                }
            );
            //Federal Piston
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Piston"),
                    NameOverride = "Federal Piston",
                    DescriptionOverride = "A cool thing that extends and contracts. Nice.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalPistonView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalPiston.png");
                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalPistonHead.png");
                    }
                }
            );
            //Colonist Generator
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Generator"),
                    NameOverride = "Colonist Generator",
                    DescriptionOverride = "Quite useful. Hydrogen goes in, electricity comes out.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistGeneratorView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistGenerator.png");
                    }
                }
            );
            //Federal Generator
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Generator"),
                    NameOverride = "Federal Generator",
                    DescriptionOverride = "A Military generator. Yeah this isn't used much, mainly for auxiliary power or just... power?",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalGeneratorView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalGenerator.png");
                    }
                }
            );
            //Big Colonist Generator
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Industrial Generator"),
                    NameOverride = "Industrial Colonist Generator",
                    DescriptionOverride = "Yeah don't touch it. It produces something like 800 milliamperes so I wouldn't touch it if I were you.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistBigGenView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistBigGenerator.png");
                    }
                }
            );
            //Big Federal Generator
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Industrial Generator"),
                    NameOverride = "Industrial Federal Generator",
                    DescriptionOverride = "A Generator mainly used in trailers of Federal Military Generators.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalBigGenView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalBigGenerator.png");
                    }
                }
            );
            //Colonist Rotor
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rotor"),
                    NameOverride = "Colonist Rotor",
                    DescriptionOverride = "A device capable of making an object spin.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistRotorView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistServoBase.png");
                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistRotor.png");
                    }
                }
            );
            //Federal Rotor
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rotor"),
                    NameOverride = "Federal Rotor",
                    DescriptionOverride = "A device capable of making an object spin, but it's armored.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalRotorView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalServoBase.png");
                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalRotor.png");
                    }
                }
            );
            //Federal Servo
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Servo"),
                    NameOverride = "Federal Servo",
                    DescriptionOverride = "Rotates at a specific angle. For Military purposes.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalServoView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalServoBase.png");
                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalRotor2.png");
                        Instance.transform.GetChild(1).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ServoArm.png");
                    }
                }
            );
            //Federal Thruster
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Thruster"),
                    NameOverride = "Federal Thruster",
                    DescriptionOverride = "A stronger version of it's civilian counterpart.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalThrusterView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalThruster.png");
                    }
                }
            );
            //Federal Battery
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Battery"),
                    NameOverride = "Federal Battery",
                    DescriptionOverride = "A compact electric energy generator.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalBatteryView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/federalbattery.png");
                    }
                }
            );
            //Large Federal Battery
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Accumulator"),
                    NameOverride = "Large Federal Battery",
                    NameToOrderByOverride = "14",
                    DescriptionOverride = "A larger federal battery used mainly in military vehicles.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalLargeBatteryView.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/HeavyBattery.png");
             	     Instance.FixColliders();

                     var phys = Instance.GetComponent<PhysicalBehaviour>();
                     phys.Properties = ModAPI.FindPhysicalProperties("Metal");
                    }
                }
            );
            //Colonist Wheel
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "Colonist Motorised Wheel",
                    DescriptionOverride = "A wheel for vehicles.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistMotorView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistMotor.png");
                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistWheel.png");
                    }
                }
            );
            //Federal Wheel
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "Federal Motorised Wheel",
                    DescriptionOverride = "A wheel for military vehicles.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalMotorView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalMotor.png");
                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalWheel.png");
                    }
                }
            );
            //Colonist Seat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bus Chair"),
                    NameOverride = "Colonist Seat",
                    DescriptionOverride = "Here. Sit.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistSeatView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("sprite/ColonistSeat.png"),

                        };
                    }
                }
            );
            //Federal Seat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bus Chair"),
                    NameOverride = "Federal Seat",
                    DescriptionOverride = "A less comfy version of the regular seat.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSeatView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("sprite/FederalSeat.png"),

                        };
                    }
                }
            );
            //Colonist Gastank
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Red Barrel"),
                    NameOverride = "Colonist Gastank",
                    DescriptionOverride = "A tank that holds liquid hydrogen.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistGastankView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistGastank.png");
                        	Instance.FixColliders();
                    }
                }
            );
            //Federal Gastank
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Red Barrel"),
                    NameOverride = "Federal Gastank",
                    DescriptionOverride = "A tank that holds liquid hydrogen.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalGastankView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalGastank.png");
                        	Instance.FixColliders();
                    }
                }
            );
            //Colonist Hydrogen Engine
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                    NameOverride = "Colonist Hydrogen Engine",
                    DescriptionOverride = "The Colonist Hydrogen Engine. Advanced and super efficient, this is a go-to for almost every vehicle.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistEngineView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistEngine.png");
                        	Instance.FixColliders();
                    }
                }
            );
            //Federal Hydrogen Engine
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                    NameOverride = "Federal Hydrogen Engine",
                    DescriptionOverride = "Bulkier, armored, and thirsty. The colonist engineers did some tinkering with the regular hydrogen engine, and managed to make a military-suitable version of it. Unlike it's civilian counterpart, it is much less efficient.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalEngineView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalEngine.png");
                        	Instance.FixColliders();
                    }
                }
            );
            //Arcanian EM Drive
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "The Four Drive",
                    DescriptionOverride = "The Four Drive, when activated, jumps into the fourth dimension to do some wacky tacky stuff, and somehow reaches FTL.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/EMDriveView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/EMDriveRevamp.png");
                        	Instance.FixColliders();
                    }
                }
            );
            //Colonist Knife
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Colonist Knife",
                    NameToOrderByOverride = "8",
                    DescriptionOverride = "A knife. For cutting and stabbing.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistKnifeView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistKnife.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal Knife
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Knife"),
                    NameOverride = "Federal Combat Knife",
                    NameToOrderByOverride = "8",
                    DescriptionOverride = "Used by Federal units as a standard issue combat knife.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalKnifeView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalKnife.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Colonist Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Colonist Defense Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "Used by the exploration-focused colonists to defend themselves against extraterrestrial threats.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistRifleView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("assault1.wav"),
			ModAPI.LoadSound("assault2.wav"),
			ModAPI.LoadSound("assault3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistRifle.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Tahi Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Tahi Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "A rifle borrowed from the Federal Army, refitted with new optics and repainted.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTahiRifleView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("assault1.wav"),
			ModAPI.LoadSound("assault2.wav"),
			ModAPI.LoadSound("assault3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTahiRifleRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Rua Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Rua Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "An ordinary defence force rifle.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRuaRifleView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("assault1.wav"),
			ModAPI.LoadSound("assault2.wav"),
			ModAPI.LoadSound("assault3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRuaRifleRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Toru Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Toru Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "An ordinary defence force rifle.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivToruRifleView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("assault1.wav"),
			ModAPI.LoadSound("assault2.wav"),
			ModAPI.LoadSound("assault3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivToruRifleRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Wha Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Wha Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "An ordinary defence force rifle.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhaRifleView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("assault1.wav"),
			ModAPI.LoadSound("assault2.wav"),
			ModAPI.LoadSound("assault3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhaRifleRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Rimu Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Rimu Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "Lots of unneeded parts were removed from the original rifle to create a lighter rifle for Division Rimu's heavy worlds.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRimuRifleView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("assault1.wav"),
			ModAPI.LoadSound("assault2.wav"),
			ModAPI.LoadSound("assault3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRimuRifleRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Ono Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Ono Rifle",
                    NameToOrderByOverride = "8",
                    DescriptionOverride = "A rifle capable of supporting an underbarrel flamethrower.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoRifle.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("drum1.wav"),
			ModAPI.LoadSound("drum2.wav"),
			ModAPI.LoadSound("drum3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivOnoRifleRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Ono Flamethrower
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Flamethrower"),
                    NameOverride = "Division Ono Underbarrel Flamethrower",
                    NameToOrderByOverride = "5",
                    DescriptionOverride = "Dispenses Propane. Also dispenses oxygen due to the lack of an atmosphere on many planets Division Ono patrol.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoFlamethrowerView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivOnoFlamethrower.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Whitu Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Whitu Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "An ordinary defence force rifle.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhituRifleView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("assault1.wav"),
			ModAPI.LoadSound("assault2.wav"),
			ModAPI.LoadSound("assault3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhituRifleRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Waru Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Waru Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "An ordinary defence force rifle, with a close-range sight.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWaruRifleView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("assault1.wav"),
			ModAPI.LoadSound("assault2.wav"),
			ModAPI.LoadSound("assault3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWaruRifleRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Iwa Bullpup
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Iwa Bullpup Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "An ordinary defence force rifle... except it's a bullpup. And suppressed (what??)",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivIwaBullpupView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gunsilenced1.wav"),
			ModAPI.LoadSound("gunsilenced2.wav"),
			ModAPI.LoadSound("gunsilenced3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivIwaRifleRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Tekau Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Tekau Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "A rifle capable of functioning in the high pressures of gas giants.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTekauRifleView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("assault1.wav"),
			ModAPI.LoadSound("assault2.wav"),
			ModAPI.LoadSound("assault3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTekauRifleRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Paladin Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("PPSH"),
                    NameOverride = "Division Paladin Rifle",
                    NameToOrderByOverride = "6",
                    DescriptionOverride = "A rifle capable of functioning in the damned chromosphere of a star.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTRifleView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("assault1.wav"),
			ModAPI.LoadSound("assault2.wav"),
			ModAPI.LoadSound("assault3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTRifle.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Colonist 20mm
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Colonist 20mm",
                    NameToOrderByOverride = "5",
                    DescriptionOverride = "A fast firing 20mm autocannon for non-military structures/vehicles.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Colonist20mmView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("auto3.wav"),
			ModAPI.LoadSound("auto4.wav"),
			};

			firearm.barrelPosition = new Vector3(0.3f,0f);

            		Cartridge customCartridge = ModAPI.FindCartridge("30 mm"); 
            		customCartridge.name = "Colonist 30mm Automatic"; 
                        firearm.AutomaticFireInterval = 0.1f;
                        firearm.Automatic = true;

                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Colonist20mm.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal 20mm
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Federal 20mm",
                    NameToOrderByOverride = "5",
                    DescriptionOverride = "A 20mm cannon with a higher firerate than the civilian version.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Federal20mmView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("auto3.wav"),
			ModAPI.LoadSound("auto4.wav"),
			};

			firearm.barrelPosition = new Vector3(0.3f,0f);

            		Cartridge customCartridge = ModAPI.FindCartridge("30 mm"); 
            		customCartridge.name = "Colonist 30mm Automatic"; 
                        firearm.AutomaticFireInterval = 0.08f;
                        firearm.Automatic = true;

                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Federal20mm.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Harrison 120mm
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Detached 120mm Cannon"),
                    NameOverride = "The Harrison 120mm Cannon",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "It's a 120mm barrel used by the Harrison main battle tank, firing HEAT rounds.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Harrison120mmView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/Federal120mm.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Arcanian 120mm 
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Detached 120mm Cannon"),
                    NameOverride = "The Arcanian 120mm Cannon",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A bulky, advanced barrel used by the Arcanian main battle tank, firing devastating HESH rounds.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Arcanian120mmView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/arcanian barrel.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "Federal Rifle",
                    NameToOrderByOverride = "Firearm",
                    DescriptionOverride = "An advanced rifle carried by Federal Soldiers, capable of swiftly executing enemies",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalRifleView.png"),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("drum1.wav"),
			ModAPI.LoadSound("drum2.wav"),
			ModAPI.LoadSound("drum3.wav"),
			};
			firearm.barrelPosition = new Vector3(0.65f,0.106f);
                        firearm.Automatic = true;
                        firearm.AutomaticFireInterval = 0.08f;
                        firearm.InitialInaccuracy = 0.001f;

                   	Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalRifleRevamped.png");
                   	Instance.FixColliders();

            		Cartridge customCartridge = ModAPI.FindCartridge("5.56x45mm"); 
            		customCartridge.name = "Assault Rifle -CRM";
                        customCartridge.Damage *= 3.8f; 
			customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.StartSpeed *= 1.2f;
                        customCartridge.ImpactForce = 0.6f;
            		firearm.Cartridge = customCartridge;

                        ModAPI.KeepExtraObjects();
                        var Slide = Instance.transform.Find("Slide");
                        Slide.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalRifleSlide.png");
                        Slide.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;

            		var Cover = new GameObject("Cover");
            		Cover.transform.SetParent(Instance.transform);
            		Cover.transform.rotation = Instance.transform.rotation;
            		Cover.transform.localPosition = new Vector3(0f, 0f);
            		Cover.transform.localScale = new Vector3(1f, 1f);
            		var CoverSprite = Cover.AddComponent<SpriteRenderer>();
            		CoverSprite.sprite = ModAPI.LoadSprite("sprite/FederalRifleCover.png");
                        CoverSprite.GetComponent<SpriteRenderer>().sortingOrder = Instance.GetComponent<SpriteRenderer>().sortingOrder + 1;
                    }
                }
            );
            //Federal Shotgun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Shotgun"),
                    NameOverride = "Federal Shotgun",
                    NameToOrderByOverride = "7",
                    DescriptionOverride = "A shotgun with a holographic sight.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalShotgun.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("shotgunNP1.wav"),
			ModAPI.LoadSound("shotgunNP2.wav"),
			ModAPI.LoadSound("shotgunNP3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalShotgunRevamped.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal Sniper Rifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sniper Rifle"),
                    NameOverride = "Federal Sniper Rifle",
                    NameToOrderByOverride = "5",
                    DescriptionOverride = "An advanced long range rifle used by Federal Snipers.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSniperView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
          ModAPI.LoadSound("sns.mp3"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalSniperRifle.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal Superrifle
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rifle"),
                    NameOverride = "SR-98 Anti-Tank Sniper",
                    DescriptionOverride = "On the verge of being ruled out by federal law, this weapon was designed to tear through tank armor. It is commonly wielded by federal androids but sometimes used by heavy soldiers. The design originates from the long-lost Copper Republic...",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSuperSniperView.png"),
                    AfterSpawn = (Instance) =>
                    {
            var firearm = Instance.GetComponent<FirearmBehaviour>();
            firearm.ShotSounds = new AudioClip[]
            {
            ModAPI.LoadSound("BL-44_A.wav"),
            ModAPI.LoadSound("BL-44_B.wav"),
            ModAPI.LoadSound("BL-44_C.wav"),
            };
            firearm.InitialInaccuracy = 0f;
            firearm.BulletsPerShot = 8;
            firearm.barrelPosition = new Vector3(0.9f,0.08f);

                       Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalSuperSniper.png");
                       Instance.FixColliders();

                    Cartridge customCartridge = ModAPI.FindCartridge("30 mm"); 
                    customCartridge.name = "BL-44 Superheavy Combat Rifle -CRM";
                        customCartridge.Damage *= 160f; 
                    customCartridge.Recoil *= 0.04f;
                    customCartridge.ImpactForce *= 0.08f;
            customCartridge.PenetrationRandomAngleMultiplier *= 0f;
                        customCartridge.StartSpeed *= 1.2f; 
                    firearm.Cartridge = customCartridge;
                    }
                }
            );
            //Division Toru Grenade
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Handgrenade"),
                    NameOverride = "Division Toru Grenade",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A grenade used by Division Toru of the Colonist Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivToruGrenadeView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivToruGrenade.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal Sticky Grenade
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Sticky Grenade"),
                    NameOverride = "Federal Sticky Grenade",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Once activated, a set of few thousand nano-bots surgically attach the grenade to a target, making it damn near impossible to take off.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalStickyGrenadeView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalStickyGrenade.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Colonist Handgun
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Colonist Handgun",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "Used by security forces to rival crime in the system of Arcanus.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistHandgunView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Tahi Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Division Tahi Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "A pistol with a cool camo design.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTahiPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTahiPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Rua Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Division Rua Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "A red pistol, pretty cool looking not going to lie.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRuaPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRuaPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Toru Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Division Toru Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "It's loud, it's deadly.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivToruPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivToruPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Wha Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Division Wha Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "It's a pistol.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhaPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhaPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Rimu Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Division Rimu Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "It's a pistol.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRimuPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRimuPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Ono Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Division Ono Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "It's a pistol.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivOnoPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Whitu Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Division Whitu Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "It's a pistol, and it's invisible in the snow.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhituPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhituPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Waru Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Division Waru Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "It's a pistol... except it's invisible in a desert.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWaruPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWaruPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Iwa Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Division Iwa Pistol",
                    NameToOrderByOverride = "5",
                    DescriptionOverride = "It's suppressed, it's deadly.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivIwaPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gunsilenced1.wav"),
			ModAPI.LoadSound("gunsilenced2.wav"),
			ModAPI.LoadSound("gunsilenced3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivIwaPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Division Tekau Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Division Tekau Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "It's a pistol, it's invisible in the clouds of Arcanus.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTekauPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTekauPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Federal Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "A pistol. Yeah I think there's like 20 other pistols in this mod but whatever.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal Navy Pistol
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Glock 17"),
                    NameOverride = "Federal Navy Pistol",
                    NameToOrderByOverride = "4",
                    DescriptionOverride = "A Federal Pistol... but white.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/MichaelLambPistolView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("gun1.wav"),
			ModAPI.LoadSound("gun2.wav"),
			ModAPI.LoadSound("gun3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/MichaelLambPistol.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal Reconstructor
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Reconstructor"),
                    NameOverride = "Federal Reconstructor.",
                    NameToOrderByOverride = "8",
                    DescriptionOverride = "A prototype healing device.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalReconstructorView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalReconstructor.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal Grenade Launcher
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Grenade Launcher"),
                    NameOverride = "Federal Grenade Launcher",
                    NameToOrderByOverride = "8",
                    DescriptionOverride = "Fires little grenades, nice.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalGrenadeLauncherView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalGrenadeLauncher.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Federal LMG
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Light Machine Gun"),
                    NameOverride = "Federal Light Machine Gun",
                    NameToOrderByOverride = "8",
                    DescriptionOverride = "A heavy weapon. Mostly used by androids.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalLMGView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
			var firearm = Instance.GetComponent<FirearmBehaviour>();
			firearm.ShotSounds = new AudioClip[]
			{
			ModAPI.LoadSound("lmg1.wav"),
			ModAPI.LoadSound("lmg2.wav"),
			ModAPI.LoadSound("lmg3.wav"),
			};
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalLMG.png", 1f);
                   	Instance.FixColliders();
                    }
                }
            );
            //Colonist Wrench
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Wrench"),
                    NameOverride = "Colonist Wrench",
                    DescriptionOverride = "Made of titanium, it is used to repair and build machinery.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistWrenchView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistWrench.png");
                        	Instance.FixColliders();
                    }
                }
            );
            //Federal Wrench
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Wrench"),
                    NameOverride = "Federal Wrench",
                    DescriptionOverride = "Made of tungsten, this wrench is carried by Federal Androids to repair themselves in combat.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalWrenchView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalWrench.png");
                        	Instance.FixColliders();
                    }
                }
            );
            //Colonist EVA Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Colonist EVA Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An ordinary EVA helmet used by the colonists.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistCivilianHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistCivilianHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Oxygen Mask
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Oxygen Mask",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A rebreather that recycles oxygen. Compatible with Oxygen Tanks and EVA packs. Supplies an occupant with 5 minutes of oxygen given the occupant breathes calmly and slowly.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/OxygenMaskView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/OxygenMask.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Tahi Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Tahi Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Tahi.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTahiHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTahiHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Tahi Non-Combat Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Tahi Non-Combat Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Tahi Non-Combat members.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTahiNonCombatHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTahiNonCombatHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Rua Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Rua Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Rua.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRuaHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRuaHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Rua Non-Combat Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Rua Non-Combat Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Rua Non-Combat members.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRuaNonCombatHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRuaNonCombatHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Rua Commander Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Rua Commander Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Rua Commanders",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRuaCommanderHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRuaCommanderHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Toru Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Toru Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Toru.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivToruHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivToruHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Toru Non-Combat Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Toru Non-Combat Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Toru Non-Combat members.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivToruNonCombatHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivToruNonCombatHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Toru Commander Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Toru Commander Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Toru Commanders",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivToruCommanderHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivToruCommanderHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Wha Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Wha Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Wha.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhaHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhaHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Wha Non-Combat Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Wha Non-Combat Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Wha Non-Combat members.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhaNonCombatHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhaNonCombatHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Wha Commander Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Wha Commander Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Wha Commanders",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhaCommanderHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhaCommanderHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Rimu Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Rimu Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Rimu.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRimuHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRimuHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Rimu Non-Combat Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Rimu Non-Combat Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Rimu Non-Combat members.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRimuNonCombatHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRimuNonCombatHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Rimu Commander Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Rimu Commander Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Rimu Commanders",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRimuCommanderHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRimuCommanderHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Ono Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Ono Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Ono.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivOnoHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Ono Non-Combat Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Ono Non-Combat Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Ono Non-Combat members.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoNonCombatHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivOnoNonCombatHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Ono Commander Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Ono Commander Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Ono Commanders",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoCommanderHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivOnoCommanderHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Whitu Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Whitu Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Tekau.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhituHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhituHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Whitu Non-Combat Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Whitu Non-Combat Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Whitu Non-Combat members.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhituNonCombatHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhituNonCombatHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Whitu Commander Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Whitu Commander Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Whitu Commanders",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhituCommanderHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhituCommanderHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Waru Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Waru Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Waru.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWaruHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWaruHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Waru Non-Combat Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Waru Non-Combat Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Waru Non-Combat members.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWaruNonCombatHelmet.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWaruNonCombatHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Waru Commander Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Waru Commander Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Waru Commanders",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWaruCommanderHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWaruCommanderHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Iwa Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Iwa Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Iwa.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivIwaHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivIwaHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Iwa Non-Combat Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Iwa Non-Combat Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Iwa Non-Combat members.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivIwaNonCombatHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivIwaNonCombatHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Iwa Commander Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Iwa Commander Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Iwa Commanders",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivIwaCommanderHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivIwaCommanderHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Tekau Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Tekau Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Tekau.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTekauHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTekauHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Tekau Non-Combat Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Tekau Non-Combat Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Tekau Non-Combat members.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTekauNonCombatHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTekauNonCombatHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Tekau Commander Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Tekau Commander Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet for Division Tekau Commanders",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTekauCommanderHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTekauCommanderHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
          //Federal Sailor Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Sailor Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A white version of the Federal Soldier helmet with a wider visor.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSailorHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalSailorHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
          //Federal Soldier Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Soldier Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Think of it like this. A defense force helmet but meant for offense.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSoldierHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/NewFederalSoldierHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
          //Federal Pilot Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Pilot Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A regular Federal Army helmet with a bigger visor for a wider FOV.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalPilotHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalPilotHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
          //Federal Grenadier Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Grenadier Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "These helmets have no visor, but rather a tungsten plate with a high-fidelity 16K resolution camera, to protect them against blast shrapnel.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalGrenadierHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalGrenadierHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 44f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 18;

                        Instance.FixColliders();
                    }
                }
            );
          //Federal Medic Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Medic Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Federal Helmet with a red cross.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalMedicHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalMedicHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
          //Federal Sniper Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Sniper Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet with a rangefinder that has a max range of 3KM.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSniperHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalSniperHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
          //Federal Heavy Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Heavy Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A really heavy helmet that can stop a fifty cal round right in it's tracks.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSoldierHeavyHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalSoldierHeavyHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Colonist Industrial Piston
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Industrial Piston"),
                    NameOverride = "Colonist Industrial Piston",
                    DescriptionOverride = "Works at the same principle as the normal piston.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistIndustrialPistonView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistIndustrialPiston.png");
                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistIndustrialPistonHead.png");
                    }
                }
            );
            //Federal Industrial Piston
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Industrial Piston"),
                    NameOverride = "Federal Industrial Piston",
                    DescriptionOverride = "A fatter, larger, bulkier, more bullet resistant, more blast resistant, more meat resistant big fat metal door. Well, what else would you use them for?",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalIndustrialPistonView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalIndustrialPiston.png");
                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalIndustrialPistonHead.png");
                    }
                }
            );
            //Colonist Security Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Colonist Security Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A protective helmet used by security. It is reinforced with titanium making it stronger than a regular helmet.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistSecurityHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistSecurityHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 33f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 14;

                        Instance.FixColliders();
                    }
                }
            );
            //Colonist Scientist Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Colonist Scientific Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Worn by scientists of all different fields, this helmet has special identification abilities which allows the user to identify any material it is looking at.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistScientistHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistScientistHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Colonist Prime Minister Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Prime Minister's EVA Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "John Harrison's EVA helmet. It is rather heavy, being reinforced with bulletproof tungsten.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/PrimeMinisterEVAHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/PrimeMinisterEVAHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 44f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 16;

                        Instance.FixColliders();
                    }
                }
            );
            //Colonist Explorer Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Colonist Exploration Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Worn by exploration colonists. This specific helmet has advanced life support systems, allowing an occupant to survive in harsh conditions (with the full EVA suit) for a whopping 6 months.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistExplorerHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistExplorerHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Colonist Pilot Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Colonist Pilot Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Used by piloting colonists. It has advanced communication systems to keep in touch with various colonies whilst in the air or in space.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistPilotHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistPilotHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Colonist Medic Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Colonist Medic Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "This variant of EVA helmets has advanced life detection systems, allowing the occupant to identify the heartbeat of a target, the integrity of a target, and any diseases/infections the target has.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistMedicHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistMedicHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Fuse
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Activation Fuse"),
                    NameOverride = "Federal Fuse",
                    DescriptionOverride = "Safely autodestructs if activated.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalFuseView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalFuse.png");
                    }
                }
            );
            //Carter Clark Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Carter Clark's Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "It is Carter Clark's special EVA Helmet, with advanced life support systems, an occupant can survive in harsh conditions for atleast 4 months.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/CarterClarkHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/CarterClarkHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Colonist Engineer Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Colonist Mechanic Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "This helmet deals with all things technical. Identifying the model of the target and identifying what is required to fix/repair the target.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistMechanicHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistMechanicHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Colonist Ballistic Upper
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Prime Minister EVA Armor Piece",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Simple but effective ballistic armor to protect the Prime Minister against bullets.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/PrimeMinisterUpperBallisticView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/PrimeMinisterUpperBallistic.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Grenadier Lower
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Grenadier Lower Armor Piece",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Used to protect the lower portion of the torso against bomb shrapnel.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/GrenadierLowerPiece.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalLowerBallistic.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 44f;
                        armor.armorPiece = "LowerBody";
                        armor.armorTier = 18;

                        Instance.FixColliders();
                    }
                }
            );
            //Carter Clark Hair
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Carter Clark Hair",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Carter Clark Hair",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/CarterClarkHairView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/CarterClarkHair.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Prime Minister Hair
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Prime Minister Hair",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "John Harrison's... Hair",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/PrimeMinisterHairView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/PrimeMinisterHair.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Black Hair
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Black Hair 1",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Black hair",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/BlackHairView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/MatthewPakalHair.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );	
            //Brown Hair
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Brown Hair 1",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Brown Hair",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/BrownHairView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/NathanHemiHair.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Black Hair Female
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Black Hair 2",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Black hair",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/BlackHair2View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistBlackHair2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Brown Hair Female
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Brown Hair 2",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Brown Hair",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/BrownHair2View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistBrownHair2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 1;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "It's an EVA pack... with life support...",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/EVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/EVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Oxygen Tank
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Oxygen Tank",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An oxygen tank. Compatible with the oxygen mask. Can supply an oxygen mask with roughly one hour of oxygen.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/OxygenTankView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/OxygenTank.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Tahi EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Tahi EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An EVA pack but it's camo so you can't actually see it lol",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTahiEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTahiEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );

            //Division Rua EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Rua EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An EVA pack with an extended antenna for advanced communications.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRuaEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRuaEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Toru EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Toru EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An EVA pack but smaller and designed to withstand the crushing pressures of Arcanus 3.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivToruEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivToruEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Wha EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Wha EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An ordinary EVA pack.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhaEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhaEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Rimu EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Rimu EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An ordinary EVA pack.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRimuEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRimuEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Ono EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Ono EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An EVA pack with a fuel tank. For burning things.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivOnoEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Ono Non Combat EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Ono Non Combat EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An EVA pack without a fuel tank.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoNonCombatEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivOnoNonCombatEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Whitu EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Whitu EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An EVA pack with advanced heaters. Pretty neat.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhituEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhituEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Waru EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Waru EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An ordinary EVA pack with a cool desert camo design.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWaruEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWaruEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Iwa EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Iwa EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An EVA pack but black...",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivIwaEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivIwaEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division Tekau EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Tekau EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A small EVA pack with a relatively large thruster that can lift an occupant out of the intense gravity of Arcanus.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTekauEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTekauEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division TmT Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Mirror"),
                    NameOverride = "Division Paladin Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A helmet with advanced mirrored plating, and an extremely shaded visor, to protect the user's vision from the stars they work around.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division TmT EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Mirror"),
                    NameOverride = "Division Paladin EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An EVA pack with intense cooling and reflection systems.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Division TmT Faulds
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Mirror"),
                    NameOverride = "Division Paladin Faulds",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A piece of protective armor with reflective plating designed to protect the lower waist area.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTFauldView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTFauld.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "LowerBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //TmT Rerebrace 1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Mirror"),
                    NameOverride = "Division Paladin Rerebrace 1",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Mirror plated armor for the upper arm.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTRerebrace1View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTRerebrace.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperArmFront";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //TmT Rerebrace 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Paladin Rerebrace 2",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Mirror plated armor for the upper arm.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTRerebrace2View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTRerebrace2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperArm";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //TmT Gauntlet 1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Paladin Gauntlet 1",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Mirror plated armor for the lower arm.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTGauntletView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTGauntlet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "LowerArmFront";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //TmT Gauntlet 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Paladin Gauntlet 2",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Mirror plated armor for the lower arm.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTGauntletView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTGauntlet2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "LowerArm";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //TmT Tasset 1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Mirror"),
                    NameOverride = "Division Paladin Tasset 1",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Mirror plated armor for the upper leg.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTTassetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTTasset.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperLegFront";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //TmT Tasset 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Paladin Tasset 2",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Mirror plated armor for the upper leg.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTTassetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTTasset2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperLeg";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //TmT Greave 1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Paladin Greave 1",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Mirror plated armor for the lower leg.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTGreaveView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTGreave.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "LowerLegFront";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //TmT Greave 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Paladin Greave 2",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Mirror plated armor for the lower leg.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTGreaveView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTmTGreave2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "LowerLeg";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Rerebrace 1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Rerebrace 1",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Armor for the upper arm.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalRerebrace1View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalRerebrace.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperArmFront";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Rerebrace 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Rerebrace 2",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Armor for the upper arm.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalRerebrace2View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalRerebrace2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperArm";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Gauntlet 1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Gauntlet 1",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Armor for the lower arm.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalGauntletView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalGauntlet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "LowerArmFront";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Gauntlet 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Gauntlet 2",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Armor for the lower arm.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalGauntletView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalGauntlet2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "LowerArm";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Tasset 1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Tasset 1",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Armor for the upper leg.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalTasset1View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalTasset.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperLegFront";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Tasset 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Tasset 2",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Armor for the upper leg.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalTasset2View.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalTasset2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperLeg";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Greave 1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Greave 1",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Armor for the lower leg.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalGreaveView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalGreave.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "LowerLegFront";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Greave 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Greave 2",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Armor for the lower leg.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalGreaveView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalGreave2.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "LowerLeg";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Sailor EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Sailor EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A regular EVA pack. Neat.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSailorEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalSailorEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Heavy Soldier EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Heavy EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A very heavy EVA pack. Neat.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalHeavyEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalHeavyEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Soldier EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Soldier EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A regular EVA pack. Neat.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSoldierEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/NewFederalsoldierEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Grenadier EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Grenader EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A shortened EVA pack with lots of armor, and lots of explosives. I wonder what it's all for...",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalGrenadierEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/GrenadierEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 44f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 18;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Paratrooper EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Paratrooper EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A very slim EVA pack to fit the parachute-devices that paratroopers carry.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalParatrooperEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalParatrooperEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Medic EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Medic EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An EVA Pack designed to carry a portable defibrillator.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalMedicEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalMedicEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Sniper EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Sniper EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "An EVA pack with a rangefinder. Combined with the Federal Sniper Helmet, it has a max range of 8KM.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSniperEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalSniperEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Prime Minister EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Prime Minister EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "EVA Pack",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/PrimeMinisterEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/PrimeMinisterEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Carter ClarkEVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Carter Clark's EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Carter clark thing",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/CarterClarkEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/CarterClarkEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Ammo Box
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal LMG Ammunition Box",
                    NameToOrderByOverride = "14",
                    DescriptionOverride = "A box that carries ammunition for the LMG, well, any weapons really.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalAmmoBoxView.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalAmmoBox.png");
                   	Instance.FixColliders();
                    }
                }
            );
            //Security MP5
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Stunner"),
                    NameOverride = "Security Stun Gun",
                    NameToOrderByOverride = "5",
                    DescriptionOverride = "Used by security forces as a means of non-lethal immobilization weaponry.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/SecurityStunGunView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/SecurityStunGun.png", 1f);
                   	Instance.FixColliders();

			var firearm = Instance.GetComponent<FirearmBehaviour>();
                        firearm.AutomaticFireInterval = 0.13f;
                        firearm.Automatic = true;
                    }
                }
            );
            //Warhead
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Pink Explosive"),
                    NameOverride = "Torpedo Warhead",
                    NameToOrderByOverride = "14",
                    DescriptionOverride = "A warhead capable of destroying even the most strongest of armor.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalBombView.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalBomb.png");
                    }
                }
            );
            //Arcanian Shock Detector
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Shock Detector"),
                    NameOverride = "Arcanian Shock Detector",
                    DescriptionOverride = "Sends a signal when detects shock.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ShockDetectorView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ShockDetector.png");
                    }
                }
            );
            //Colored Tungsten Rod
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bulletproof Sheet"),
                    NameOverride = "Colored Tungsten Rod",
                    NameToOrderByOverride = "14",
                    DescriptionOverride = "A tungsten rod for military use.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalTungstenRodView.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColoredTungstenRod.png");
                    }
                }
            );
            //Titanium Rod
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Titanium Rod",
                    NameToOrderByOverride = "14",
                    DescriptionOverride = "A rod made out of titanium, extracted from Arcanus 2.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/TitaniumRodView.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/TitaniumRod.png");
                    }
                }
            );
            //Titanium Rod Half
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Titanium Rod Half",
                    NameToOrderByOverride = "15",
                    DescriptionOverride = "A regular Titanium rod with half the length.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/TitaniumRodHalfView.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/TitaniumRodHalf.png");
                   	Instance.FixColliders();
                    }
                }
            );
            //Tungsten Rod Background
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bulletproof Sheet"),
                    NameOverride = "Background Rod",
                    NameToOrderByOverride = "14",
                    DescriptionOverride = "Used for making backgrounds. Disable collisions for this one.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/BackgroundRodView.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Bottom";
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/BackgroundRod.png");
                    }
                }
            );
            //Tungsten Rod
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bulletproof Sheet"),
                    NameOverride = "Tungsten Rod",
                    NameToOrderByOverride = "14",
                    DescriptionOverride = "Made of the strongest metal known to the colonists, tungsten, it is extracted from Arcanus 2 and used for many purposes.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/TungstenRodView.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/TungstenRod.png");
                    }
                }
            );
            //Tungsten Rod Half
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Bulletproof Sheet"),
                    NameOverride = "Tungsten Rod Half",
                    NameToOrderByOverride = "14",
                    DescriptionOverride = "A tungsten rod, but shorter.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/TungstenRodHalfView.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/TungstenRodHalf.png");
                   	Instance.FixColliders();
                    }
                }
            );
            //Colonist Beam
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("I-Beam"),
                    NameOverride = "Colored Beam",
                    NameToOrderByOverride = "16",
                    DescriptionOverride = "This is made of a colored titanium.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColoredTitaniumBeamView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("sprite/ColoredTitaniumBeam.png"),

                        };

                    }
                }
            );
            //Colonist Beam Small
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Small I-Beam"),
                    NameOverride = "Small Colored Beam",
                    NameToOrderByOverride = "17",
                    DescriptionOverride = "A shorter colored titanium beam.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColoredTitaniumBeamHalfView.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColoredTitaniumBeamShort.png");
                   	Instance.FixColliders();
                    }
                }
            );
            //Blue blood colonist
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Bare Colonist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "The Arcanian (Commonly referred to as a Colonist) has delicate blue skin, and blue muscles, caused by the copper enriched blue blood.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/Scientist1.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Colonist 1
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Colonist Civilian 1",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A Colonist with a nice white t-shirt.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Colonist1View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/Colonist1.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Colonist 2
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Colonist Civilian 2",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A Colonist with a nice blue t-shirt.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Colonist2View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/Colonist2.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Colonist 3
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Colonist Civilian 3",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A Colonist with a nice grey t-shirt.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Colonist3View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/Colonist3.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Colonist 4
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Colonist Civilian 4",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A Colonist with a nice white shirt.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Colonist1View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/Colonist10.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Colonist 5
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Colonist Civilian 5",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A Colonist with a nice blue shirt.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Colonist2View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/Colonist11.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Colonist 6
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Colonist Civilian 6",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A Colonist with a nice grey shirt.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/Colonist3View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/Colonist12.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Tahi EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Tahi Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Tahi guard all of the Habitable worlds that the Arcanians have colonized. They have the same gear as the Federal Army.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTahiEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivTahiEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Tahi Non-Combat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Tahi Non-Combat unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A non-combat unit for Division Tahi of the Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTahiReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivTahiReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Tahi Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Tahi Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Cap for Division Tahi",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTahiCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTahiCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Div Rua EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Rua Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Rua guard all of the mineral-rich worlds that the Arcanians have colonized. They have pretty much the same gear as the Federal Army.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRuaEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivRuaEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Rua Non-Combat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Rua Non-Combat unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A non-combat unit for Division Rua of the Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRuaReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivRuaReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Rua Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Rua Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Cap for Division Rua",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRuaCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRuaCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Div Toru EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Toru Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Toru guard all of the toxic, deadly worlds that the Arcanians have colonized. They have reinforced armor, advanced life support systems, and a weak exoskeleton.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivToruEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivToruEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Toru Non-Combat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Toru Non-Combat unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A non-combat unit for Division Toru of the Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivToruReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivToruReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Toru Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Toru Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Cap for Division Toru",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivToruCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivToruCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Div Wha EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Wha Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Wha guard all of the light worlds that the Arcanians have colonized. They are trained to work well in low-g environments.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhaEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivWhaEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Wha Non-Combat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Wha Non-Combat unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A non-combat unit for Division Wha of the Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhaReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivWhaReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Wha Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Wha Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Cap for Division Wha",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhaCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhaCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Div Rimu EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Rimu Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Rimu guard all of the heavy worlds that the Arcanians have colonized. They have exoskeletons to help them with the immense gravity.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRimuEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivRimuEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 20f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Rimu Non-Combat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Rimu Non-Combat unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A non-combat unit for Division Rimu of the Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRimuReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivRimuReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                                body.Health *= 20f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Rimu Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Rimu Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Cap for Division Rimu",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivRimuCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivRimuCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Div Ono EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Ono Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Ono guard all of the hot worlds that the Arcanians have colonized. They have advanced cooling systems to help mitigate heat.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivOnoEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Ono Non-Combat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Ono Non-Combat unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A non-combat unit for Division Ono of the Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivOnoReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Ono Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Ono Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Cap for Division Ono",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivOnoCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivOnoCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Div Whitu EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Whitu Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Whitu guard all of the cold worlds that the Arcanians have colonized. With advanved insulation and heating systems.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhituEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivWhituEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Whitu Non-Combat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Whitu Non-Combat unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A non-combat unit for Division Whitu of the Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhituReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivWhituReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Whitu Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Whitu Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Cap for Division Whitu",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWhituCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWhituCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Div Waru EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Waru Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Waru guard all of the sandy, terraformable worlds that the Arcanians have colonized. They have the same gear as the Federal Army but with a few extra bits and bobs.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWaruEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivWaruEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Waru Non-Combat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Waru Non-Combat unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A non-combat unit for Division Waru of the Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWaruReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivWaruReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Waru Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Waru Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Cap for Division Waru",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivWaruCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivWaruCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Div Iwa EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Iwa Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Iwa guard all of the space inside arcanian territory, with core bases hidden in interstellar space. They have suits designed for zero-g.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivIwaEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivIwaEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Iwa Non-Combat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Iwa Non-Combat unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A non-combat unit for Division Iwa of the Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivIwaReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivIwaReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Iwa Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Iwa Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Cap for Division Iwa",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivIwaCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivIwaCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Div Tekau EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Tekau Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Tekau defend any colonized gas giants in arcanian territory. They also sometimes work with Division Whitu to guard ice giants.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTekauEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivTekauEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Tekau Non-Combat
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Tekau Non-Combat unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "A non-combat unit for Division Tekau of the Defense Force",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTekauReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivTekauReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Div Tekau Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Division Tekau Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "A Cap for Division Tekau",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTekauCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/DivTekauCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Div TmT EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Division Paladin Specialist",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Division Paladin is a group of elite members hand-picked from other divisions to work in and around stars. Guarding structures, maintaining the condition of the stars, and protecting the Junus Dyson Sphere.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/DivTmTEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/DivTmTEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 15f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Federal Sailor
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Federal Sailor",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "These guys are the backbone of the Federal Navy. Piloting the massive warships that defend Arcanus, from battling massive wars in orbit to taking down simple pirate corvettes.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalSailorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/FederalSailor.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Federal Soldier
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Federal Soldier",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "These guys are the backbone of the Federal Army. From full on wars to simple crime managment, they're not to be messed with.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalArmySoldierView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/NewFederalSoldier.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Federal Medic
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Federal Medic",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Federal Medics are exactly what their name suggests. Medics. With defibrillators. Yeah pretty neat.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalArmySoldierView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/FederalMedic.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Federal Reserve
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Federal Non-Combat Unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Federal Non-Combat units don't directly engage in combat, they manage assault teams, provide dispatch, and doing everything behind the scenes.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalArmyReserveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/FederalArmyReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Federal Non-Combat Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "For non-combat units.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Heavy Rod
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("1000kg Weight"),
                    NameOverride = "Heavy Rod",
                    NameToOrderByOverride = "14",
                    DescriptionOverride = "The Colonists found a classified, very dense material.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/HeavyRodView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("sprite/HeavyRod.png"), 
                        };
                    }
                }
            );
            //Colonist Android
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Colonist Android",
                    DescriptionOverride = "Sentient androids to be used in dangerous situations, for testing, and as companions.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/TecVarColonistAndroidView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprite/Colonist Android.png");
                        var flesh = ModAPI.LoadTexture("sprite/TecVar Muscles.png");
                        var bone = ModAPI.LoadTexture("sprite/TecVar Bones.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );
            //Android EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Android EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Not needed for inorganic beings. But is handy nonetheless.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/AndroidEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/AndroidEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 12;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Android
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Android"),
                    NameOverride = "Federal Android",
                    DescriptionOverride = "Sentient androids created to serve the Arcanian Armed Forces.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/TecVarFederalAndroidView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprite/Federal Android.png");
                        var flesh = ModAPI.LoadTexture("sprite/TecVar Muscles.png");
                        var bone = ModAPI.LoadTexture("sprite/TecVar Bones.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin, flesh, bone);
                    }
                }
            );
            //FedAndroid EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Android EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Not needed for inorganic beings. But is handy nonetheless.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalAndroidEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalAndroidEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 24;

                        Instance.FixColliders();
                    }
                }
            );
            //FedAndroid Recon EVA Pack
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Android Recon EVA Pack",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "Not needed for inorganic beings. But is handy nonetheless. Has one insane rangefinder.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalAndroidReconEVAPackView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalAndroidReconEVAPack.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();


                        armor.stabResistance = 22f;
                        armor.armorPiece = "UpperBody";
                        armor.armorTier = 24;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Android Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Android Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "The life support has been removed, as androids don't need it. Other than that, it's a regular federal helmet.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalAndroidHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalAndroidHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 44f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 16;

                        Instance.FixColliders();
                    }
                }
            );
            //Federal Android Recon Helmet
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Federal Android Recon Helmet",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "The life support has been removed, as androids don't need it. Other than that, it's a regular federal sniper's helmet.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalAndroidReconHelmetView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalAndroidReconHelmet.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();

                        armor.stabResistance = 44f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 16;

                        Instance.FixColliders();
                    }
                }
            );
            //Colonist EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Colonist EVA",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Colonist in an EVA suit.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/CivilianEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Security EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Security EVA",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Security in an EVA suit.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/SecurityEVA.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Security Reserve
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Security Non-Combat Unit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Security Non-Combat units don't directly engage in combat. They perform investigations, monitor search teams, and do everything behind the scenes.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/SecurityNonCombatView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/SecurityReserve.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {



                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Security Non-Combat Cap
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Security Cap",
                    NameToOrderByOverride = "9",
                    DescriptionOverride = "For non-combat units.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/SecurityCapView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/SecurityCap.png");
                        ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
                        armor.threepieces = false;

                        armor.stabResistance = 2f;
                        armor.armorPiece = "Head";
                        armor.armorTier = 2;

                     	var phys = Instance.GetComponent<PhysicalBehaviour>();
                     	phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        Instance.FixColliders();
                    }
                }
            );
            //Prime Minister EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Prime Minister's EVA Suit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "The Prime Minister's EVA suit is reinforced with tungsten, making it heavy but protectant.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/PrimeMinisterEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var skin = ModAPI.LoadTexture("sprite/PrimeMinisterEVASuit.png");
                        var flesh = ModAPI.LoadTexture("sprite/BlueFleshLayer.png");
                        var bone = ModAPI.LoadTexture("sprite/BoneLayer.png");
                        Instance.GetComponent<PersonBehaviour>().SetBodyTextures(skin);

			var person = Instance.GetComponent<PersonBehaviour>();

                        foreach (var body in person.Limbs)
                        {
                            body.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        }

			person.SetBodyTextures(skin, flesh, bone, 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134); 
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                    }
                }
            );
            //Prime Minister EVA
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Prime Minister's EVA Suit",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "The Prime Minister's EVA suit is reinforced with tungsten, making it heavy but protectant.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/PrimeMinisterEVAView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/PrimeMInisterEVASuit.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Prime Minister
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Prime Minister",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "The Prime Minister of the Colonist Federation.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/PrimeMinisterView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/PrimeMInister.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Carter Clark
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Carter G' Clark",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Carter Clark is a legendary explorer. Making major strides in the exploration of the federation.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/CarterClarkView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/CarterClark.png"), ModAPI.LoadTexture("sprite/BlueFleshLayer.png"), ModAPI.LoadTexture("BoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Michael Lamb
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Human"),
                    NameOverride = "Michael Q. Lamb",
                    NameToOrderByOverride = "1",
                    DescriptionOverride = "Sergeant Lamb lost his legs to a falling building. The Colonist Federation invented a pair of robotic legs, Michael was the first one to receive them, becoming the first Colonist Cyborg.",
                    CategoryOverride = ModAPI.FindCategory("CoA -People"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/MichaelLambView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        var person = Instance.GetComponent<PersonBehaviour>();
                        var prop = UnityEngine.Object.Instantiate<PhysicalProperties>(person.Limbs[0].PhysicalBehaviour.Properties);
                        person.SetBodyTextures(ModAPI.LoadTexture("sprite/MichaelLamb.png"), ModAPI.LoadTexture("sprite/MichaelLambMuscleLayer.png"), ModAPI.LoadTexture("MichaelLambBoneLayer.png"), 1);
			person.SetBruiseColor(11, 29, 134); 
			person.SetSecondBruiseColor(11, 29, 134);  
			person.SetThirdBruiseColor(11, 29, 134); 
                        person.SetRottenColour(202, 199, 104);
                        person.SetBloodColour(4, 0, 108);
                        var cal = ScriptableObject.CreateInstance<DecalDescriptor>();
                        var cal2 = ScriptableObject.CreateInstance<DecalDescriptor>();
                        
                        foreach (LimbBehaviour limb in person.Limbs)
                        {
                            foreach (var body in person.Limbs)
                        {


                            body.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                                body.Health *= 10f;
                              
                            }
                            

                            cal.Sprites = limb.BloodDecal.Sprites;
                            cal.IgnoreRadius = limb.BloodDecal.IgnoreRadius;
                            cal.Color = new Color(0, 0, 0.4f, 1f);
                            limb.BloodDecal = cal; //Lazy
                            limb.BloodLiquidType = "Copper Enriched Blood";
                            limb.CirculationBehaviour.Drain(limb.CirculationBehaviour.Limits.y);
                            limb.CirculationBehaviour.AddLiquid(Liquid.GetLiquid("Copper Enriched Blood"), limb.CirculationBehaviour.Limits.y);
                            limb.PhysicalBehaviour.Properties = prop;
                        }
                        var Safe = new GameObject();
                        person.BleedingParticlePrefab = UnityEngine.Object.Instantiate<GameObject>(person.BleedingParticlePrefab, Safe.transform);
                        person.BloodExplosionPrefab = UnityEngine.Object.Instantiate<GameObject>(person.BloodExplosionPrefab, Safe.transform);
                        prop.ShotImpact = UnityEngine.Object.Instantiate<GameObject>(prop.ShotImpact, Safe.transform);
                        Safe.SetActive(false);
                        cal2.Sprites = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.Sprites;
                        cal2.IgnoreRadius = person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal.IgnoreRadius;
                        cal2.Color = new Color(0, 0, 0.4f, 1f);
                        person.BleedingParticlePrefab.GetComponentInChildren<BleedingParticleBehaviour>().BloodSplatController.Decal = cal2; //again

                        foreach (var thi in person.BleedingParticlePrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var main = person.BleedingParticlePrefab.GetComponentInChildren<ParticleSystem>().main;
                            main.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (thi.gameObject.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                thi.gameObject.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                            var renderer = thi.gameObject.GetComponent<ParticleSystemRenderer>();
                            renderer.material.color = new Color32(4, 0, 108, 255);
                        }

                        foreach (var thi in person.BloodExplosionPrefab.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                        }

                        foreach (var con in person.BloodExplosionPrefab.GetComponentsInChildren<FancyBloodSplatController>())
                        {
                            con.Decal = cal2;
                        }

                        foreach (var thi in prop.ShotImpact.GetComponentsInChildren<ParticleSystem>())
                        {
                            var moon = thi.main;
                            moon.startColor = new ParticleSystem.MinMaxGradient(new Color32(4, 0, 108, 255));
                            if (prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>())
                            {
                                prop.ShotImpact.GetComponentInChildren<FancyBloodSplatController>().Decal = cal2;
                            }
                        }
                    }
                }
            );
            //Colonist Laser Pointer
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Laser Pointer"),
                    NameOverride = "Colonist Laser Pointer",
                    DescriptionOverride = "A laser pointer used by the explorers of the Colonists as attachments on their defense rifles.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/ColonistLaserPointerView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/ColonistLaserPointer.png");
                    }
                }
            );
            //Federal Beam
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("I-Beam"),
                    NameOverride = "Federal Beam",
                    NameToOrderByOverride = "16",
                    DescriptionOverride = "This is made of a colored Tungsten.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/FederalBeamView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<RandomSpriteBehaviour>().sprites = new Sprite[]
                        {
                            ModAPI.LoadSprite("sprite/FederalBeam.png"),

                        };

                    }
                }
            );
            //Federal Thermonuclear Bomb
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Fusion Bomb"),
                    NameOverride = "The Black Star",
                    DescriptionOverride = "Disowned by it's founders, and protested by the public. The Black Star is death itself. Designed for use against high-value targets and capital warships, it's power is unmatched by anything the Arcanians have built.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tools"),
                    ThumbnailOverride = ModAPI.LoadSprite("view/BlackStarView.png", 5f),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/FederalThermonuclearBomb.png");
                    }
                }
            );
            //Blackcube
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Map Cube",
                    NameToOrderByOverride = "MAP",
                    DescriptionOverride = "For simple map making.",
                    CategoryOverride = ModAPI.FindCategory("CoA -Tech"),
                    ThumbnailOverride = ModAPI.LoadSprite("sprite/BlackCube.png"),
                    AfterSpawn = (Instance) =>
                    {
                     Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("sprite/BlackCube.png");
                   	Instance.FixColliders();

                        Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";

                        var phys = Instance.GetComponent<PhysicalBehaviour>();
                        phys.Properties = ModAPI.FindPhysicalProperties("Soft");
                        phys.Disintegratable = false;
                	phys.Deletable = false;
                        phys.Properties.Flammability = 0f;
                        phys.Properties.BulletSpeedAbsorptionPower = float.MaxValue;
                    }
                }
            );


        }
    }
}
public class Purp : Liquid
{
    public Purp()
    {
        this.Color = new Color32(4, 0, 108, 255);
    }

    public override void OnEnterContainer(BloodContainer container)
    {
    }

    public override void OnEnterLimb(LimbBehaviour limb)
    {
        if (limb.SpeciesIdentity == "Android" && UnityEngine.Random.value > 0.995f)
        {
            limb.PhysicalBehaviour.Charge += 0.1f;
        }
    }

    public override void OnExitContainer(BloodContainer container)
    {
    }

    public const string ID = "Copper Enriched Blood";
}
    